package com.io.yutian.elementoriginlib.command;

import org.bukkit.Bukkit;
import org.bukkit.World;
import org.bukkit.entity.Player;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

public class Suggests {

    public static final Suggest WORLD_LIST = ()->{
        List<String> list = new LinkedList<>();
        for (World world : Bukkit.getWorlds()) {
            list.add(world.getName());
        }
        return list;
    };

    public static final Suggest PLAYER_LIST = ()->{
        List<String> list = new LinkedList<>();
        for (Player player : Bukkit.getOnlinePlayers()) {
            list.add(player.getName());
        }
        return list;
    };

    private static final Map<String, Suggest> suggests = new HashMap<>();

    public static void registerSuggest(String name, Suggest suggest) {
        suggests.put(name, suggest);
    }

    public static Suggest getSuggest(String name) {
        return suggests.get(name);
    }

    public static void unregisterSuggest(String name) {
        suggests.remove(name);
    }

    static {

        registerSuggest("world_list", WORLD_LIST);
        registerSuggest("player_list", PLAYER_LIST);

    }

}
