package com.io.yutian.elementoriginlib.gui;

import com.io.yutian.elementoriginlib.gui.button.Button;
import com.io.yutian.elementoriginlib.gui.button.ClickType;
import net.kyori.adventure.text.Component;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.InventoryAction;
import org.bukkit.event.inventory.InventoryClickEvent;

import java.util.Set;

public abstract class ContainerGui extends Gui {

    private Set<Integer> slots;

    public ContainerGui(Player player, Component title, int size) {
        super(player, title, size);
    }

    public void addSlot(int slot) {
        if (slot > inventory.getSize()) {
            return;
        }
        slots.add(slot);
    }

    @Override
    public void handler(Player player, int slot, InventoryClickEvent event) {
        if (buttons.containsKey(slot)) {
            Button button = buttons.get(slot);
            if (button == null) {
                if (slot < inventory.getSize()) {
                    event.setCancelled(true);
                } else {
                    if (event.getAction().equals(InventoryAction.MOVE_TO_OTHER_INVENTORY)) {
                        event.setCancelled(true);
                    }
                }
                return;
            }
            event.setCancelled(true);
            clickButton(event, slot, button);
            if (button.isPlaySound()) {
                player.playSound(player.getLocation(), Sound.UI_BUTTON_CLICK, 1.0f, 1.0f);
            }
            InventoryAction action = event.getAction();
            ClickType clickType = ClickType.LEFT_CLICK;
            if (action.equals(InventoryAction.PICKUP_ALL)) {
                clickType = ClickType.LEFT_CLICK;
            } else if (action.equals(InventoryAction.PICKUP_HALF)) {
                clickType = ClickType.RIGHT_CLICK;
            } else if (action.equals(InventoryAction.MOVE_TO_OTHER_INVENTORY)) {
                clickType = ClickType.SHIFT_CLICK;
            }
            if (button.getClickConsumer() != null) {
                button.getClickConsumer().accept(player, clickType);
            }
        } else {
            if (slot < inventory.getSize()) {
                event.setCancelled(true);
            }
        }
    }

}
