package com.io.yutian.elementoriginlib.gui.button;

import com.io.yutian.elementoriginlib.tag.ItemProxy;
import com.io.yutian.elementoriginlib.tag.TagString;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;

import java.util.function.BiConsumer;
import java.util.function.BiPredicate;
import java.util.function.Function;

public class ItemButton extends Button {

    private BiConsumer<Player, ItemStack> clickItemConsumer;

    private Function<ItemStack, ItemStack> putItemFunction;
    private BiPredicate<Player, ItemStack> putPredicate;

    private ItemStack item;

    public ItemButton(ItemStack itemStack) {
        super(itemStack);
        ItemProxy itemProxy = new ItemProxy(itemStack);
        itemProxy.editTag((nbtCompound -> {
            nbtCompound.putString("gui_meta", "item_button");
        }));
        setItemStack(itemProxy.getItemStack());
    }

    public ItemButton setItem(ItemStack item) {
        this.item = item;
        return this;
    }

    public ItemStack getItem() {
        return item;
    }

    public ItemButton itemPredicate(BiPredicate<Player, ItemStack> predicate) {
        this.putPredicate = predicate;
        return this;
    }

    public ItemButton putItem(Function<ItemStack, ItemStack> putItemFunction) {
        this.putItemFunction = putItemFunction;
        return this;
    }

    public boolean isItem() {
        return isItem(item);
    }

    public boolean isItem(ItemStack item) {
        ItemProxy itemProxy = new ItemProxy(item);
        return itemProxy.has("gui_meta", TagString.TYPE_ID) && ((TagString) itemProxy.get("gui_meta")).getString().equals("item_button");
    }

    public ItemButton clickItem(BiConsumer<Player, ItemStack> consumer) {
        this.clickItemConsumer = consumer;
        return this;
    }

    public BiConsumer<Player, ItemStack> getClickItemConsumer() {
        return clickItemConsumer;
    }

    public Function<ItemStack, ItemStack> getPutItemFunction() {
        return putItemFunction;
    }

    public BiPredicate<Player, ItemStack> getPutPredicate() {
        return putPredicate;
    }

}