package com.io.yutian.elementoriginlib.item.stat.data;

import com.io.yutian.elementoriginlib.item.stat.StatData;

import java.util.Objects;

public class EnumData<E extends Enum> implements StatData {

    private E value;

    public EnumData(E value) {
        this.value = value;
    }

    public E getValue() {
        return value;
    }

    public void setValue(E value) {
        this.value = value;
    }

    @Override
    public boolean isEmpty() {
        return value == null;
    }

    @Override
    public String toString() {
        return "EnumData{" +
                "value=" + value +
                '}';
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        EnumData<?> enumData = (EnumData<?>) o;
        return Objects.equals(value, enumData.value);
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(value);
    }
}
