package com.io.yutian.elementoriginlib.item.stat.data;

import com.io.yutian.elementoriginlib.item.stat.Mergeable;
import com.io.yutian.elementoriginlib.item.stat.StatData;
import org.jetbrains.annotations.NotNull;

import java.util.List;

public class ListData<V> implements StatData, Mergeable<ListData<V>> {

    private List<V> list;

    public ListData(List<V> list) {
        this.list = list;
    }

    public List<V> getList() {
        return list;
    }

    public void add(V value) {
        this.list.add(value);
    }

    @Override
    public void merge(ListData<V> var1) {
        this.list.addAll(var1.getList());
    }

    @NotNull
    @Override
    public ListData<V> cloneData() {
        return new ListData(list);
    }

    @Override
    public boolean isEmpty() {
        return list.isEmpty();
    }

}
