package com.io.yutian.elementoriginlib.item.stat.data;

import com.io.yutian.elementoriginlib.item.stat.Mergeable;
import com.io.yutian.elementoriginlib.item.stat.StatData;
import org.jetbrains.annotations.NotNull;

import java.util.Map;

public class MapData implements StatData, Mergeable<MapData> {

    private Map<String, Object> map;

    public MapData(Map<String, Object> map) {
        this.map = map;
    }

    public Object get(String key) {
        return map.get(key);
    }

    public Object getOrDefault(String key, Object defaultValue) {
        return map.getOrDefault(key, defaultValue);
    }

    public void put(String key, Object value) {
        map.put(key, value);
    }

    public void remove(String key) {
        map.remove(key);
    }

    public boolean containsKey(String key) {
        return map.containsKey(key);
    }

    public Map<String, Object> getMap() {
        return map;
    }

    @Override
    public void merge(MapData var1) {
        this.map.putAll(var1.map);
    }

    @Override
    public @NotNull MapData cloneData() {
        return new MapData(this.map);
    }

    @Override
    public boolean isEmpty() {
        return map.isEmpty();
    }

}
