package com.io.yutian.elementoriginlib.listener;

import com.io.yutian.elementoriginlib.ElementOriginLib;
import com.io.yutian.elementoriginlib.chatinput.PlayerChatInput;
import com.io.yutian.elementoriginlib.manager.PlayerChatInputManager;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.player.AsyncPlayerChatEvent;
import org.bukkit.plugin.Plugin;

public class PlayerChatInputListener extends IListener {

    public PlayerChatInputListener(Plugin plugin) {
        super(plugin);
    }

    @EventHandler(priority = EventPriority.LOWEST, ignoreCancelled = true)
    public void onPlayerChat(AsyncPlayerChatEvent event) {
        if (PlayerChatInputManager.hasInput(event.getPlayer())) {
            event.setCancelled(true);
            String string = event.getMessage();
            Player player = event.getPlayer();
            Bukkit.getScheduler().runTask(ElementOriginLib.inst(), ()-> {
                PlayerChatInput playerInput = PlayerChatInputManager.getInput(player);
                if (string.toLowerCase().trim().equalsIgnoreCase("取消") || string.toLowerCase().trim().equalsIgnoreCase("none") || string.toLowerCase().trim().equalsIgnoreCase("cancle")) {
                    playerInput.cancle();
                    PlayerChatInputManager.removeInput(player);
                    player.sendMessage("playerchatinput.cancle");
                    return;
                }
                playerInput.call(string);
                if (playerInput.isCall() || playerInput.isCancel()) {
                    PlayerChatInputManager.removeInput(player);
                }
            });
        }
    }

}
